<template>
  <div>
    <b-button
      class="deleteBtn"
      variant="danger"
      :disabled="isWaitingForResponse || isLoading || !isResourceOwner"
      v-b-modal.modal-prevent-closing
      >{{ $t("DeleteButton") }}</b-button
    >
    <b-modal
      id="modal-prevent-closing"
      ref="modal"
      :displayName="displayName"
      :title="$t('DeleteModalHeadline')"
      @show="resetModal"
      @hidden="resetModal"
      @ok="handleOk"
    >
      <form ref="form" @submit.stop.prevent="handleSubmit">
        <b-form-group
          :state="deleteInputState"
          :label="$t('DeleteModalDescription')"
          label-for="delete_name_input"
        >
          <div id="displayName">
            {{ this.displayName }}
          </div>
          <b-form-input
            id="delete_name_input"
            v-model="deleteName"
            :state="deleteInputState"
            required
            @change="disableHelp"
          ></b-form-input>
          <div class="invalid-tooltip" v-show="showHelp">
            {{ $t("DeleteModalHelp") }}
          </div>
        </b-form-group>
      </form>
      <template v-slot:modal-footer="{ ok, cancel }">
        <b-button variant="secondary" @click="cancel()">
          {{ $t("cancel") }}
        </b-button>
        <b-button
          :disabled="isWaitingForResponse || isLoading"
          variant="danger"
          @click="ok()"
        >
          {{ $t("DeleteButton") }}
        </b-button>
      </template>
    </b-modal>
  </div>
</template>

<script lang="ts">
import Vue from "vue";

export default Vue.extend({
  name: "DeleteModal",
  data() {
    return {
      deleteName: "",
      deleteInputState: null,
      showHelp: false,
    };
  },
  props: {
    displayName: String,
    isResourceOwner: {
      default: false,
      type: Boolean,
    },
    isWaitingForResponse: {
      default: false,
      type: Boolean,
    },
    isLoading: {
      default: false,
      type: Boolean,
    },
  },
  methods: {
    checkFormValidity() {
      let valid = (this.$refs.form as any).checkValidity();
      if (this.deleteName !== this.displayName) {
        valid = false;
      }
      this.deleteInputState = valid;
      return valid;
    },
    disableHelp() {
      this.showHelp = false;
    },
    resetModal() {
      this.deleteName = "";
      this.deleteInputState = null;
    },
    handleOk(bvModalEvt: any) {
      if (!this.checkFormValidity()) {
        this.showHelp = true;
        return;
      }
      this.$emit("deleteResource");
    },
  },
});
</script>

<style>
.modal-header .modal-title {
  margin-block-start: 0;
  margin-block-end: 0;
  margin-left: 0;
}
.modal-header button.close {
  text-align: end;
  min-width: 1em;
}
.modal footer button {
  min-width: auto;
}
</style>

<style scoped>
.invalid-tooltip {
  margin-top: -20px;
}
#displayName {
  font-size: large;
  padding-bottom: 0.3em;
}
</style>
